unit Main;

interface

uses Windows, SysUtils, Classes, Graphics, Forms, Controls, Menus,
  StdCtrls, Dialogs, Buttons, Messages, ExtCtrls, ComCtrls, StdActns,
  ActnList, ToolWin, ImgList;

type
  TMainForm = class(TForm)
    MainMenu: TMainMenu;
    File1: TMenuItem;
    FileOpenItem: TMenuItem;
    FileCloseItem: TMenuItem;
    Window1: TMenuItem;
    Help1: TMenuItem;
    N1: TMenuItem;
    FileExitItem: TMenuItem;
    WindowCascadeItem: TMenuItem;
    WindowTileItem: TMenuItem;
    WindowArrangeItem: TMenuItem;
    HelpAboutItem: TMenuItem;
    OpenDialog: TOpenDialog;
    FileSaveAsItem: TMenuItem;
    WindowMinimizeItem: TMenuItem;
    StatusBar: TStatusBar;
    WindowTileItem2: TMenuItem;
    ImageList1: TImageList;
    CoolBar: TCoolBar;
    ToolBar: TToolBar;
    tbAddinsList: TToolButton;
    tbOpen: TToolButton;
    ToolButton3: TToolButton;
    tbWindow: TToolButton;
    Animate: TAnimate;
    ToolButton2: TToolButton;
    tbExit: TToolButton;
    pmWindow: TPopupMenu;
    N2: TMenuItem;
    ActionList: TActionList;
    Action1: TAction;
    WindowArrange1: TWindowArrange;
    WindowCascade1: TWindowCascade;
    WindowClose1: TWindowClose;
    WindowMinimizeAll1: TWindowMinimizeAll;
    WindowTileHorizontal1: TWindowTileHorizontal;
    WindowTileVertical1: TWindowTileVertical;
    Arrange1: TMenuItem;
    Cascade1: TMenuItem;
    MinimizeAll1: TMenuItem;
    TileHorizontally1: TMenuItem;
    TileVertically1: TMenuItem;
    mnuEdit: TMenuItem;
    ImageList2: TImageList;
    procedure FormCreate(Sender: TObject);
    procedure FileExitItemClick(Sender: TObject);
    procedure tbOpenClick(Sender: TObject);
    procedure tbAddinsListClick(Sender: TObject);
    procedure FileCloseItemClick(Sender: TObject);
    procedure File1Click(Sender: TObject);
    procedure mnuEditClick(Sender: TObject);
    procedure HelpAboutItemClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  MainForm: TMainForm;

implementation

{$R *.DFM}
{$R AVI.RES}

uses
  ADKMng,
  About,
  AddinList;

const
  AMSG_EXTREQUEST = 1;


procedure TMainForm.FormCreate(Sender: TObject);
var
  i, Found: integer;
  sr: TSearchRec;
  Path, Filters: string;
  custom: variant;
begin
  Animate.ResID := 9999;
  Animate.Active := true;
  { carico tutti gli Addin che trovo nella directory dell'eseguibile ... }
  Path := IncludeTrailingBackslash(ExtractFilePath(Application.EXEName));
  try
    Found := FindFirst(Path + '*.ADD', 0, sr);
    while Found = 0 do
    begin
       LoadAddin(Path + sr.Name);
       Found := FindNext(sr);
    end;
  finally
    FindClose(sr);
  end;
  { ... e li interrogo per sapere l'estensione che gestisce }
  Filters := '';
  for i:=0 to (AddinsCount - 1) do
  begin
    custom := '';
    if GetAddinByIndex(i).Connect(cmStartup, custom) then
    begin
      if Filters<>'' then
        Filters := Filters + '|';
      Filters := Filters + custom;
    end
    else
      UnloadAddin(GetAddinByIndex(i).PackageName)
  end;
  OpenDialog.Filter := Filters
end;

procedure TMainForm.FileExitItemClick(Sender: TObject);
begin
  UnloadAddins;
  Close;
end;

procedure TMainForm.tbOpenClick(Sender: TObject);
var
  i: integer;
  custom: variant;
begin
  if OpenDialog.Execute then
  begin
    for i:=0 to (AddinsCount - 1) do
    begin
       custom := OpenDialog.filename;
       GetAddinByIndex(i).SendMessage(AMSG_EXTREQUEST, custom);
       if custom then
         break;
    end;
  end;
end;

procedure TMainForm.tbAddinsListClick(Sender: TObject);
begin
  frmAddinsList := TfrmAddinsList.Create(Application);
  try
    frmAddinsList.ShowModal;
  finally
    frmAddinsList.free;
  end;
end;

procedure TMainForm.FileCloseItemClick(Sender: TObject);
begin
  ActiveMDIChild.Close;
end;

procedure TMainForm.File1Click(Sender: TObject);
begin
  FileCloseItem.enabled := Assigned(ActiveMDIChild);
end;

procedure TMainForm.mnuEditClick(Sender: TObject);
var
  i: integer;
begin
  for i:=0 to (mnuEdit.Count - 1) do
    mnuEdit.Items[i].enabled := Assigned(ActiveMDIChild) and (ActiveMDIChild.Owner.ClassName=mnuEdit.Items[i].Owner.ClassName);  
end;

procedure TMainForm.HelpAboutItemClick(Sender: TObject);
begin
  AboutBox.ShowModal;
end;

end.
