unit UnitImage;


interface


uses

  ADKMng,

  forms,  

  UnitViewImage;


const

  AMSG_EXTREQUEST = 1;


type

  TAddinImage = class(TAddin)

    procedure AddinConnection(Sender: TObject; ConnectMode: TConnectMode;
      var AllowConnection: Boolean; var custom: Variant);

    procedure AddinAddinMessage(Sender: TObject; AddinMessage: Integer;
      var MessageParam: Variant);

    procedure AddinDisconnect(Sender: TObject; RemoveMode: TDisconnectMode;
      var custom: Variant);

  private

    frmViewerImage: TfrmViewerImage;

    procedure FormClose(Sender: TObject; var Action: TCloseAction);

  public

    { Public declarations }

  end;



implementation


{$R *.DFM}


uses

  Classes,

  Sysutils,

  menus;


procedure TAddinImage.FormClose(Sender: TObject;

  var Action: TCloseAction);
begin
  Action := caFree;
  frmViewerImage := nil;
end;


procedure TAddinImage.AddinConnection(Sender: TObject;

  ConnectMode: TConnectMode; var AllowConnection: Boolean;
  var custom: Variant);
var
  menu,
  EditMenu: TMenuItem;
  //CoolBar: TCoolbar;
begin
  custom := 'Image files (*.BMP, *.JPG, *.JPEG, *.ICO, *.WMF)|*.BMP;*.JPG;*.JPEG;*.ICO;*.WMF';
  { merge user interface }
  if Assigned(Application.FindComponent('MainForm')) then
  begin
    { merge menu }
    EditMenu := TMenuItem(Application.FindComponent('MainForm').FindComponent('mnuEdit'));
    if Assigned(EditMenu) and not Assigned(EditMenu.Find('&Stretch')) then
    begin
      menu :=  TMenuItem.Create(Self);
      with menu do
      begin
        Caption := '&Stretch';
        ShortCut := Menus.ShortCut(Word('S'), [ssCtrl]);
        //OnClick := MenuFindClick;
        HelpContext := 0;
        Checked := false;
        Enabled := true;
        Name := 'mnuStretch';
      end;
      EditMenu.Add(menu);
    end;
  end;
end;

procedure TAddinImage.AddinAddinMessage(Sender: TObject;

  AddinMessage: Integer; var MessageParam: Variant);
var
  extension,
  filename: string;
begin
  if AddinMessage=AMSG_EXTREQUEST then
  begin
    filename := MessageParam;
    extension := ExtractFileExt(filename);
    MessageParam := false;
    if (CompareText(extension, '.BMP')=0) or
       (CompareText(extension, '.JPG')=0) or
       (CompareText(extension, '.JPEG')=0) or
       (CompareText(extension, '.ICO')=0) or
       (CompareText(extension, '.WMF')=0) then
    begin
      MessageParam := true;
      frmViewerImage := TfrmViewerImage.Create(self);
      frmViewerImage.Caption := filename;
      frmViewerImage.OnClose := FormClose;
      frmViewerImage.Image.Picture.LoadFromFile(filename);
      frmViewerImage.Show;
    end;
  end;
end;

procedure TAddinImage.AddinDisconnect(Sender: TObject;

  RemoveMode: TDisconnectMode; var custom: Variant);
begin
  if Assigned(frmViewerImage) then
    frmViewerImage.free;
end;

initialization

  InitAddin(hInstance, TAddinImage);


end.