unit UnitText;


interface


uses

   ADKMng,

   forms,

   UnitViewText,

   Classes,

   Dialogs;


const

  AMSG_EXTREQUEST = 1;


type

  TAddinText = class(TAddin)

    FindDialog: TFindDialog;

    procedure AddinAddinMessage(Sender: TObject; AddinMessage: Integer;
      var MessageParam: Variant);

    procedure AddinDisconnect(Sender: TObject; RemoveMode: TDisconnectMode;
      var custom: Variant);

    procedure AddinConnection(Sender: TObject; ConnectMode: TConnectMode;
      var AllowConnection: Boolean; var custom: Variant);

    procedure MenuFindClick(Sender: TObject);

    procedure FindDialogFind(Sender: TObject);

  private

    { Private declarations }

    frmViewerText: TfrmViewerText;

    procedure FormClose(Sender: TObject; var Action: TCloseAction);

  public

    { Public declarations }

  end;



implementation


{$R *.DFM}


uses

  menus,

  comctrls,

  sysutils;


procedure TAddinText.FormClose(Sender: TObject;

  var Action: TCloseAction);
begin
  Action := caFree;
  frmViewerText := nil;
end;

procedure TAddinText.MenuFindClick(Sender: TObject);
begin
  FindDialog.execute;
end;


procedure TAddinText.AddinAddinMessage(Sender: TObject;

  AddinMessage: Integer; var MessageParam: Variant);
var
  extension,
  filename: string;
begin
  if AddinMessage=AMSG_EXTREQUEST then
  begin
    filename := MessageParam;
    extension := ExtractFileExt(filename);
    MessageParam := false;
    if (CompareText(extension, '.RTF')=0) or
       (CompareText(extension, '.TXT')=0) then
    begin
      MessageParam := true;
      frmViewerText := TfrmViewerText.Create(self);
      frmViewerText.Caption := filename;
      frmViewerText.OnClose := FormClose;
      frmViewerText.RichEdit.Lines.LoadFromFile(filename);
      frmViewerText.Show;
    end;
  end;
end;

procedure TAddinText.AddinDisconnect(Sender: TObject;

  RemoveMode: TDisconnectMode; var custom: Variant);
begin
  if Assigned(frmViewerText) then
    frmViewerText.free;
end;

procedure TAddinText.AddinConnection(Sender: TObject;
  ConnectMode: TConnectMode; var AllowConnection: Boolean;
  var custom: Variant);
var
  menu,
  EditMenu: TMenuItem;
  //CoolBar: TCoolbar;
begin
  custom := 'Text files (*.TXT, *.RTF)|*.TXT;*.RTF';
  { merge user interface }
  if Assigned(Application.FindComponent('MainForm')) then
  begin
    { merge menu }
    EditMenu := TMenuItem(Application.FindComponent('MainForm').FindComponent('mnuEdit'));
    if Assigned(EditMenu) and not Assigned(EditMenu.Find('F&ind text')) then
    begin
      menu :=  TMenuItem.Create(Self);
      with menu do
      begin
        Caption := 'F&ind text';
        ShortCut := Menus.ShortCut(Word('F'), [ssCtrl]);
        OnClick := MenuFindClick;
        HelpContext := 0;
        Checked := false;
        Enabled := true;
        Name := 'mnuFind';
      end;
      EditMenu.Add(menu);
    end;
    { merge toolbar }
    {
    CoolBar := TCoolbar(Application.FindComponent('MainForm').FindComponent('CoolBar'));
    if Assigned(Coolbar) then
    begin
      //tbText.Parent := Coolbar;
      with Coolbar.Bands.Add do
      begin
        //Control := tbText;
        Text := 'Text';
      end;
    end;
    }
  end;
end;

procedure TAddinText.FindDialogFind(Sender: TObject);
var
  FoundAt: LongInt;
  StartPos, ToEnd: Integer;
  Opt: TSearchTypes;
begin
  if Assigned(Application.FindComponent('MainForm')) then
  with TRichEdit(TForm(Application.FindComponent('MainForm')).ActiveMDIChild.FindComponent('RichEdit')) do
  begin
    if frDown in FindDialog.Options then
    begin
      if SelLength <> 0 then
        StartPos := SelStart + SelLength
      else
        StartPos := 0;
      ToEnd := Length(Text) - StartPos;
    end
    else
    begin
      StartPos := 0;
      if SelLength <> 0 then
        ToEnd := SelStart
      else
        ToEnd := Length(Text);
    end;
    Opt := [];
    if frMatchCase in FindDialog.Options then
      Opt := Opt + [stMatchCase];
    if frWholeWord in FindDialog.Options then
      Opt := Opt + [stWholeWord];

    FoundAt := FindText(FindDialog.FindText, StartPos, ToEnd, Opt);
    if FoundAt <> -1 then
    begin
      frmViewerText.SetFocus;
      SelStart := FoundAt;
      SelLength := Length(FindDialog.FindText);
    end;
  end;
end;

initialization
// NOTA IMPORTANTE: Se si cambia il nome del datamodule Addin,
// ricordarsi di cambiare il tipo nella procedura sottostante.

// (Delphi cambia la dichiarazione, ma non la procedura stessa.


  InitAddin(hInstance, TAddinText);


end.